/* CanonUtilGlobal.h
 */

#if defined(__cplusplus) || defined(c_plusplus)
extern "C" {
#endif

extern char *printer;
extern char *device;
extern char *powerOffTime;
extern char *look;
extern char *browser;
extern char *language;
extern char *prgName;

typedef  void (*refreshFunction_t)(void);
 
 /* index for colorLevel */
 #define BLACK    0
 #define CYAN     1
 #define MAGENTA  2
 #define YELLOW   3
 #define LCYAN    4
 #define LMAGENTA 5
 
 typedef struct printerState_s
 {
    int  communicationError;
    int  paperError;
    int  printerError;
    int  busy;
    int  colorLevel[7];
    char installedCartridge[3];
 } printerState_t;
 
/* ink level */
#define LEVEL_LOW 1
#define LEVEL_OK  0

/* printer errors */
#define PR_ERROR  1
#define PR_HEAD   2
#define PR_WASTE  3

extern printerState_t printerState;

typedef struct list_s
{
   char *item;
   struct list_s *next;
} list_t;

extern list_t *pList;
extern list_t *dList;

typedef enum  {
   NOZZLE_CHECK,
   POW_OFF,
   CLEAN_B,
   DIS_AP_OFF,
   CLEAN_A,
   EN_AP_OFF,
   ADJUST_H,
   DIS_AP_ON,
   RESET_P,
   EN_AP_ON,
} CU_PrintActions;

typedef enum  {
   PREF,
   ABOUT,
   HELP,
   EXIT,
   CLOSE
} CU_MainActions;

extern char *AboutMsg;

#if defined(__cplusplus) || defined(c_plusplus)
}
#endif
