#include <FL/Fl.H>
#include <FL/Fl_Window.H>
#include <FL/Fl_Box.H>
#include <FL/Fl_Help_View.H>
#include <FL/Fl_Button.H>
#include <FL/Fl_Choice.H>
#include <FL/Fl_Shared_Image.H>

#include "CanonUtilGlobal.h"
#include "CanonUtilFltkUtil.h"
#include "gettext.h"
#include "fltkGl.h"

static Fl_Window    *hlpWin = 0;
static Fl_Help_View *hlpView;
static Fl_Button    *closeButton;

static void htmlCb(Fl_Widget *b, void *data) 
{
   delete hlpWin;
   hlpWin = 0;
}

void make_HelpWin(int which, char *name)
{
   int w, h;
   int ww, wh;
   if ( hlpWin == NULL )
   {
      if ( which == HELP )
      {
         ww = 550;
         wh = 400;
      }
      else
      {
         ww = 270;
         wh = 220;
      }
      hlpWin = new Fl_Window(ww,wh, name);
      hlpWin->label(prgName);
      hlpWin->size_range(500,600);

      closeButton = new Fl_Button(10, 10, 10, 10, getText("Close"));
      getTextSize((Fl_Widget*)closeButton, &w, &h);
      closeButton->size(w,h);
      closeButton->position((ww-w)/2,wh-5-h);
      setButton(closeButton);
      closeButton->callback(htmlCb, NULL);
      
      hlpView = new Fl_Help_View(0,0,ww,wh-10-h);
      Fl_Group::current()->resizable(hlpView);
      hlpWin->size_range(ww,wh);
      hlpWin->end();
      fl_register_images();
   }

   if ( which == HELP )
   {
      hlpView->load(name);
   }
   else
   {
      hlpView->value(AboutMsg);
   }
   hlpWin->set_modal();
   setGlWin(hlpWin);
   hlpWin->show();
}

