/* message box */

#include <FL/Fl.H>
#include <stdio.h>
#include <FL/Fl_Window.H>
#include <FL/Fl_Box.H>
#include <FL/Fl_Button.H>
#include <FL/Fl_Box.H>
#include <FL/Fl_Choice.H>
#include "CanonUtilGlobal.h"
#include "gettext.h"
#include "CanonUtilFltkUtil.h"
#include <stdlib.h>
#include "fltkGl.h"


static Fl_Window     *msgWin = 0;
static Fl_Box        *msgTitle;
static Fl_Box        *msgMessage;
static Fl_Button     *mbutton;
static Fl_Box        *msgSep;

static char *mainTitleLB = { "CanonBjCUtility" };

static void mbuttonCallback(Fl_Widget *w, void  *data)
{
   delete msgWin;
   msgWin = 0;
}

static void msgLayout()
{
   int tw,th;
   int mw, mh;
   int bw, bh;
   int x, y;
   int maxw= 0;

   getTextSize(msgTitle, &tw, &th);
   getTextSize(msgMessage, &mw, &mh);
   getTextSize(mbutton, &bw, &bh);
   maxw = tw;
   if ( maxw < mw ) maxw = mw;
   if ( maxw < bw ) maxw = bw;
   y = 5;
   msgTitle->resize(5,y,maxw,th);
   y += 5 + th;
   msgMessage->resize(5,y,maxw,mh);
    y += 5 + mh;

   msgSep->resize(0,y, maxw+10,1);
   y += 6;
  
   x = (maxw+10-bw)/2;
   mbutton->resize(x,y, bw, bh);
   y += 5 + bh;
   msgWin->size(maxw+ 10, y);
}

void make_MsgWin(char *message)
{
   if ( msgWin ) return;

   msgWin = new Fl_Window(10,10);
   msgWin->set_modal();
   msgWin->label(prgName);
   
   msgTitle = new Fl_Box(5, 5, 10, 10, getText(mainTitleLB));
   msgTitle->box(FL_FLAT_BOX);
   msgTitle->color(7);
   msgTitle->labelsize(18);
   msgTitle->labelcolor(1);
   msgTitle->align(FL_ALIGN_CLIP);
 
   msgMessage = new Fl_Box(5, 5, 10, 10, message);
#if HAVE_GL
    ;
#else
   if ( !useGL )
      msgMessage->box(FL_FLAT_BOX);
#endif
   msgMessage->align(FL_ALIGN_INSIDE|FL_ALIGN_LEFT);
   msgMessage->labelfont(FL_COURIER_BOLD);

   msgSep = new Fl_Box(5,5,10,5, 0);
   msgSep->box(FL_ENGRAVED_FRAME);

   mbutton = new Fl_Button(0, 0, 0, 0, getText("Close"));
   setButton(mbutton);
   mbutton->callback(mbuttonCallback, NULL);
   msgWin->end();
   msgLayout();
   setGlWin(msgWin);
   msgWin->show();
}
