/* main.cpp */

#include <FL/x.H>       /* for OS functions */
#include <string.h>
#include <stdlib.h>

#include <FL/Fl.H>
#include <FL/fl_draw.H>
#include <FL/Fl_Button.H>
#include <FL/Fl_Choice.H>
#include <stdio.h>
#include <string.h>
#include <pref.h>
#include <getPrinter.h>

#include "CanonUtilFltkMw.h"
#include <CanonUtilGlobal.h>
#include <gettext.h>
#include "fltkGl.h"

static Fl_Window *mainWin;

char *prgName;

int main(int argc, char **argv)
{
   int res;
   int i;
   char         *lang;
   char          tmpBuf[20];
   unsigned char r = 214, g = 214, b = 214; // background color */

   char *s = strrchr(argv[0], '/' );
   prgName = s ? s+1 : argv[0];

   /* look for language */
   lang = getenv("LANG");
   if ( lang == NULL )
   {
      lang = getenv("LC_MESSAGES");
      if ( lang == NULL )
      {
         lang = getenv("LC_ALL");
      }
   }

   if ( lang )
   {
      if ( strcmp("german", lang) == 0 )
      {
         strcpy(tmpBuf,"de");
      }
      else
      {
         tmpBuf[0] = lang[0];
         tmpBuf[1] = lang[1];
         tmpBuf[3] = '\0';
      }
      language = strdup(tmpBuf);
   }
   
   /* initialize */
   initResource("CanonUtil",language);
   loadPreference();

   /* set look as comming from preferences */
   if ( look && strcmp(look,"normal" ) == 0 )
   {
       useGL        = 0;
       normalButton = 1;
   }
   else if ( look && strcmp(look,"openGl" ) == 0 )
   {
       useGL        = 1;
   }
   else if ( look && strcmp(look,"shadow" ) == 0 )
   {
       useGL        = 0;
       normalButton = 0;
   }

   /* set display */
   for (i = 1; i < argc; i++)
   {
      if ( strcmp(argv[i], "-display") == 0 )
      {
         if ( argv[i+1] )
         {
            char disp[50];
            snprintf(disp, sizeof(disp), "DISPLAY=%s",argv[i+1]);
            putenv(disp);
            i++;
         }
      }
#if HAVE_GL
      else if ( strcmp(argv[i], "-gl") == 0 )
      {
         useGL = 1;
      }
#endif
      else if ( strcmp(argv[i], "-nb") == 0 )
      {
         normalButton = 1;
      }
   }
   
   /* up to now tollkit specific */
   /* build main window */
   mainWin = makeMainWindow();   
   mainWin->show();
   
   /* we can't call mainWin->show(,argc, argc); */
   for (i = 1; i < argc; i++)
   {
      if ( strcmp(argv[i], "-bg") == 0 )
      {
         if ( argv[i+1] )
         {
            fl_parse_color(argv[i+1],r,g,b);
            i++;
            Fl::background(r,g,b);
            break;
         }
      }
   }      

   res = Fl::run();

   return res;
}
